@ Name:		Stefan Rapp
@ Datum:	2020-06-28

	.file	"newGen.S"
	.text			@ legt eine Textsection fuer PrgrammCode + Konstanten an
	.align	2		@ sorgt dafuer, dass nachfolgende Anweisungen auf einer durch 4 teilbaren Adresse liegen
				@ d.h. die unteren 2 Bit sind 0

	.global	neighbors	@ nimmt das Symbol neighbors in die globale Sysmboltabelle auf
	.type	neighbors,function
neighbors:			@ r0 f, r1 r, r2 c, returns number of neighbors
	mov	r3,#50		@ calculate ip = f+r*50+c
	mul 	ip,r1,r3
	add 	ip,ip,r2
	add	ip,ip,r0	@ ip points to current cell.

	mov	r0,#0		@ clear return register for counting

	cmp	r1,#0		@ upper left
	cmpne	r2,#0		@ zero flag used to check both row=0 and col=0
	ldrne	r3,[ip,#-51]
	addne	r0,r3

	cmp	r1,#0		@ upper
				@ zero flag used to check row=0
	ldrne	r3,[ip,#-50]
	addne	r0,r3

	cmp	r1,#0		@ upper right
	cmpne	r2,#49		@ zero flag used to check both row=0 and col=49
	ldrne	r3,[ip,#-49]
	addne	r0,r3

				@ left
	cmp	r2,#0		@ zero flag used to check col=0
	ldrne	r3,[ip,#-1]
	addne	r0,r3

				@ right
	cmp	r2,#49		@ zero flag used to check col=49
	ldrne	r3,[ip,#1]
	addne	r0,r3

	cmp	r1,#19		@ lower left
	cmpne	r2,#0		@ zero flag used to check both row=19 and col=0
	ldrne	r3,[ip,#49]
	addne	r0,r3

	cmp	r1,#19		@ lower
				@ zero flag used to check row=19
	ldrne	r3,[ip,#50]
	addne	r0,r3

	cmp	r1,#19		@ lower right
	cmpne	r2,#49		@ zero flag used to check both row=19 and col=49
	ldrne	r3,[ip,#51]
	addne	r0,r3

	mov	pc,lr 		@ Ende von neighbors

.neighbors_end:
	.size	neighbors,.neighbors_end-neighbors






	.global	newGen		@ nimmt das Symbol newGen in die globale Sysmboltabelle auf
	.type	newGen,function
newGen:				@ R0 f, R1 n (return is void)
	push	{r4, r5, r6, r7, lr}
	mov	r4,r0		@ save pointer to f for indexing
	mov	r5,r1		@ save pointer to n for indexing

	// first pass: calculate number of neighbors
	mov	r6,#19		@ row counter
rowloop:
	mov	r7,#49		@ col counter
colloop:
	// call member
	// we calculate row and column from r4
	mov	r0,r4
	mov	r1,r6
	mov	r2,r7
	bl	neighbors

	// calculate index using r3 as scratch register
	mov	r3,#50
	mul	ip,r3,r6
	add	ip,ip,r7

	// store in n array
	strb	r0,[r5,ip]

	// check colloop
	subs	r7,#1
	bpl	colloop

	// check rowloop
	subs	r6,#1
	bpl	rowloop



	// second pass: apply rules
	mov r0,#0 		@ r0 dead cell
	mov r1,#1		@ r1 alive cell
	mov ip,#1000		@ counter
	sub ip,ip,#1		@ set to 999 (constant is too large)

loop:
	// fetch neighbors to r2
	ldrb	r2,[r5,ip]
	cmp	r2,#2		@ case 2: nothing needed to be done
	beq	rulesdone

	cmp	r2,#3		@ case 3: set as alive
	streqb	r1,[r4,ip]
	strneb	r0,[r4,ip]	@ default case else

rulesdone:
	// check loop
	subs	ip,#1
	bpl	loop

	pop	{r4, r5, r6, r7, pc} 	@ Ende von newGen

.newGen_end:
	.size	newGen,.newGen_end-newGen
.end				@ End of File
